﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using LEAPI;

namespace LA2A3PsampleCsharp
{
    public partial class LA2A3PSAMPLE : Form
    {
        bool connected = false;
        int lanio = 0;

        public LA2A3PSAMPLE()
        {
            InitializeComponent();
            LALanio.Init();
        }

        ~LA2A3PSAMPLE()
        {
            LALanio.End();
        }

        private void CONNECT_CheckedChanged(object sender, EventArgs e)
        {
            if (CONNECT.Checked)
            {
                try
                {
                    connect(ref lanio);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                    CONNECT.Checked = false;
                    return;
                }
                connected = true;
            }
            else
            {
                LALanio.Close(lanio);
                connected = false;
            }
        }

        private void OUTPUT_Click(object sender, EventArgs e)
        {
            if (connected != true)
            {
                MessageBox.Show("not connected");
                return;
            }
            try
            {
                output(lanio);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void INPUT_Click(object sender, EventArgs e)
        {
            if (connected != true)
            {
                MessageBox.Show("not connected");
                return;
            }
            try
            {
                input(lanio);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void connect(ref int lanio)
        {
            string ipaddress = IPADDRESS.Text;
            lanio = LALanio.ConnectDirect(ipaddress, 2000);
            if (lanio == -1)
            {
                throw new Exception("Connect error");
            }
        }

        private void output(int lanio)
        {
            int err;

            err = LALanio.AOVoltage(lanio, 0, Convert.ToInt32(AO1.Text));
            if (err == 0)
            {
                throw new Exception("Output error");
            }

            err = LALanio.AOVoltage(lanio, 1, Convert.ToInt32(AO2.Text));
            if (err == 0)
            {
                throw new Exception("Output error");
            }
        }

        private void input(int lanio)
        {
            int err, input = 0;
            err = LALanio.DI(lanio, ref input);
            if (err == 0)
            {
                throw new Exception("Input error");
            }
            INPUTTEXT.Text = String.Format("DI1:{0} DI2:{1} DI3:{2}",
                ((input & 0x01) != 0) ? "ON" : "OFF",
                ((input & 0x02) != 0) ? "ON" : "OFF",
                ((input & 0x04) != 0) ? "ON" : "OFF");
        }

    }
}
